#version 330

in vec2 TexCoord0;

out vec4 FragColor;

uniform sampler2D Texture0;
uniform float Time;
uniform float Darkening;
uniform bool CurveBlur;

void main()
{
	//ivec2 resolution = textureSize(Texture0, 0);

	float amplitude = 0.01;
	float frequency = 100;
	float animationSpeed = 3;

	if (CurveBlur)
	{
		vec2 coords = vec2(TexCoord0.x + sin(TexCoord0.y * frequency + Time * animationSpeed) * amplitude, TexCoord0.y);
		FragColor = texture(Texture0, coords) * (1.0 - Darkening);
	}
	else
	{
		FragColor = texture(Texture0, TexCoord0) * (1.0 - Darkening);
	}
}
