#version 330

in vec2 TexCoord0;
flat in vec4 Velocity0;
flat in float TTL0;
flat in uint Type0;

uniform sampler2D Texture1;
uniform sampler2D Texture2;
uniform sampler2D Texture3;

uniform float CurrentTime;

out vec4 FragColor;

void main()
{
	const float b = 0.12;
	const vec3 yellow = vec3(b, b, 0);
	const vec3 red = vec3(b, 0, 0);
	const float brightness = 1.0;

	if (Type0 == 0u) // Emitter
	{
		FragColor = vec4(0, 0, 1, 1);
	}
	else if (Type0 == 1u) // Flame
	{
		float lum = texture(Texture1, TexCoord0).r;

		vec3 color = mix(red, yellow, lum) * lum * brightness;
		float mixT = clamp(1 - exp(-TTL0 * 2), 0.0, 1.0);
		FragColor = vec4(color, lum) * mixT;
	}
	else if (Type0 == 2u) // Flame
	{
		float lum = texture(Texture2, TexCoord0).r;

		vec3 color = mix(red, yellow, lum) * lum * brightness;
		float mixT = clamp(1 - exp(-TTL0 * 2), 0.0, 1.0);
		FragColor = vec4(color, lum) * mixT;
	}
	else if (Type0 == 3u) // Flame
	{
		float lum = texture(Texture3, TexCoord0).r;

		vec3 color = mix(red, yellow, lum) * lum * brightness;
		float mixT = clamp(1 - exp(-TTL0 * 2), 0.0, 1.0);
		FragColor = vec4(color, lum) * mixT;
	}
	else
	{
		// unused
		FragColor = vec4(1, 0, 0, 1);
	}
}
