#version 420

layout (location = 0) in vec4 Position;
layout (location = 6) in vec4 Velocity;
layout (location = 7) in uint Type;
layout (location = 8) in vec4 RotScale;

uniform mat4 ModelViewMatrix;

out vData
{
	vec4 Velocity1;
	vec4 RotScale1;
	uint Type1;
	float TTL1;
} vertex;

void main()
{
	gl_Position = ModelViewMatrix * vec4(Position.xyz, 1.0f);
	vertex.Velocity1 = Velocity;
	vertex.Type1 = Type;
	vertex.TTL1 = Position.w;
	vertex.RotScale1 = RotScale;
}
