#version 420

layout (location = 0) in vec4 Position;
layout (location = 6) in vec4 Velocity;
layout (location = 7) in uvec4 TypeColor;

uniform mat4 ModelViewMatrix;

out vData
{
	vec4 Velocity1;
	uint Type1;
	float TTL1;
	vec3 Color1;
} vertex;

void main()
{
	gl_Position = ModelViewMatrix * vec4(Position.xyz, 1.0f);
	vertex.Velocity1 = Velocity;
	vertex.Type1 = TypeColor.w;
	vertex.TTL1 = Position.w;
	vertex.Color1 = vec3(TypeColor.rgb) / 255.0f;
}
