//Animation---------------------
layout (location = 9)  in uvec4 BoneIndices;
layout (location = 10) in vec4 BoneWeights;

uniform mat4 BoneMatrices[200];
uniform bool Animate = false;
//------------------------------

mat4 animationTransformation()
{
	const mat4 trafo = mat4(1.0f);
	if (!Animate) return trafo;

	// Vertex Skinning:
	//vec4 bw = BoneWeights;
	//bw = bw / (bw.x + bw.y + bw.z + bw.w); // the weights should always sum up to 1 -> therefore this is unnecessary

	return	BoneWeights.x * BoneMatrices[BoneIndices.x] +
			BoneWeights.y * BoneMatrices[BoneIndices.y] +
			BoneWeights.z * BoneMatrices[BoneIndices.z] +
			BoneWeights.w * BoneMatrices[BoneIndices.w];
}
